/*
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.karaf.cellar.shell.group;

import java.util.Collections;
import java.util.List;

import org.apache.karaf.cellar.core.Group;
import org.apache.karaf.cellar.core.shell.completer.AllGroupsCompleter;
import org.apache.karaf.shell.api.action.Argument;
import org.apache.karaf.shell.api.action.Command;
import org.apache.karaf.shell.api.action.Completion;
import org.apache.karaf.shell.api.action.lifecycle.Service;

@Command(scope = "cluster", name = "group-delete", description = "Delete a cluster group")
@Service
public class GroupDeleteCommand extends GroupSupport {

    @Argument(index = 0, name = "group", description = "The cluster group name", required = true, multiValued = false)
    @Completion(AllGroupsCompleter.class)
    String groupName;

    @Override
    protected Object doExecute() throws Exception {
        // check if the group exists
        Group group = groupManager.findGroupByName(groupName);
        if (group == null) {
            System.err.println("Cluster group " + groupName + " doesn't exist");
            return null;
        }

	    if (group.isBuiltIn()) {
	        System.err.println("Cluster group " + groupName  + " is built-in and cannot be deleted");
	        return null;
	    }

        
        List<Group> children = groupManager.getAllChildren(group);
        children.add(group);
        
        for (Group g: children)
		    // check if the group doesn't contain nodes
		    if (g.getNodes() != null && !g.getNodes().isEmpty()) {
		        System.err.println("Cluster group " + g.getName()  + " is not empty");
		        return null;
		    }
        
        
        Collections.reverse(children);
        
        for (Group g: children)
        	groupManager.deleteGroup(g.getName());

        return null;
    }

}
